﻿using System;
using System.Collections.Generic;
using IntervalTree;

namespace Spring.Utilities.Collections.RangeTree
{
    public class RangeTreeFunc<TU, TV> : IntervalTree<TU, Func<TU, TV>>
    {
#region Public Methods

        public new IEnumerable<TV> Query(TU value)
        {
            foreach (var func in base.Query(value))
            {
                yield return func.Invoke(value);
            }
        }

#endregion
    }
}
